<?php

namespace SuperRhino\Utils\SubTable;

interface DateSubTableInterface {

    /**
     * 分表key
     * @return string
     */
    public static function getSubtableKeyColumn(): string;

    /**
     * 子表表名
     * @param int $time
     * @return string
     */
    public static function subTableName(int $time): string;

    /**
     * 子表表名 指定后缀
     * @param string $suffix 后缀
     * @return string
     */
    public static function subTableNameBySuffix(string $suffix): string;

    /**
     * 子表字符串后缀
     * @param int $time
     * @return string
     */
    public static function getSubTableSuffix(int $time): string;

    /**
     * 下一张表时间
     * @param int $time
     * @return int
     */
    public static function getNextSubTableDateTime(int $time): int;

    /**
     * 检查子表是否存在
     * @param int $time
     * @return bool
     */
    public static function checkSubTableExists(int $time): bool;

    /**
     * 创建对应日期的子表
     * @param string $tableName
     * @return bool
     */
    public static function createSubTable(string $tableName): bool;

}